/*
  žּŹ : 졼ե󥹰Ź
*/
#include "RailFence.h"

/*
  졼ե󥹰Ź沽 : ʸʤʬƸߤ˽񤤤ơ˽Ϥ롣

  char* src : Ź沽оʸ
  char* enc : Ź沽ʸǼ륨ꥢ
  char* enc_end : enc
  unsigned int step : ʬ
  unsigned int word : ٤Ϥʸ

  Ex. abcdefghistep=3,word=2ǽ

  ab    gh
    cd    i
      ef
      
  abghcdief
*/
void rail_fence_encryption( char* src, char* enc, char* enc_end, unsigned int step, unsigned int word )
{
  unsigned int len = strlen( src ); /* srcʸ */
  char* src_end = src + len; /* src */
  int i, j;

  if ( step == 0 || word == 0 ) return;

  for ( i = 0 ; i < step ; i++ ) {
    char* s = src + i * word;
    while ( s < src_end && enc < enc_end - 1 ) {
      for ( j = 0 ; j < word ; j++ ) {
	if ( s >= src_end || enc >= enc_end - 1 ) break;
	*enc++ = s[j];
      }
      s += step * word;
    }
    if ( enc >= enc_end - 1 ) break;
  }

  *enc = '\0';
}

/*
  ʬ䤵륰롼פγƥ

  unsigned int len : ʸĹ
  unsigned int step : ʬ
  unsigned int word : ٤Ϥʸ
  unsigned int* group_size : ƥ롼פΥϿ륨ꥢ

  Ex. abcdfeghistep=3,word=2ǽ

  ab|cd|ef|gh|i 5ϤΤǡstep
  ab,gh  cd,i  ef Υ롼פʬ䤵롣äƳƥ4,3,2
*/
void calc_group_size( unsigned int len, unsigned int step, unsigned int word, unsigned int* group_size )
{
  int i;
  unsigned int min_group_size = ( ( len / word ) / step ) * word; /* ƥ롼פʸκǾ */

  for ( i = 0 ; i < step ; i++ )
    group_size[i] = min_group_size;

  int r = len - min_group_size * step; /* 롼פ˳Ƥʬʳü */

  /* üʬƬΥ롼פ˳ */
  for ( i = 0 ; i < step ; i++ ) {
    if ( r <= 0 ) break;
    group_size[i] += ( ( r > word ) ? word : r );
    r -= word;
  }
}

/*
  졼ե沽

  char* enc : Ź沽ʸ
  char* src : 沽ʸǼ륨ꥢ
  char* src_end : src
  unsigned int step : ʬ
  unsigned int word : ٤Ϥʸ
*/
void rail_fence_decryption( char* enc, char* src, char* src_end, unsigned int step, unsigned int word )
{
  unsigned int len = strlen( enc ); /* encʸ */
  unsigned int group_size[step]; /* stepʸ */
  int i, j;

  if ( step == 0 || word == 0 ) return;

  calc_group_size( len, step, word, group_size );
  for ( i = 0 ; i < step ; i ++ ) {
    char* e = enc;            /* stepΰŹʸƬݥ */
    enc += group_size[i];     /* encϸstepؤ褦ˤ */
    char* s = src + i * word; /* step沽Ƭ */
    while ( e < enc && s < src_end ) {
      for ( j = 0 ; j < word ; j++ ) {
	if ( e >= enc || s + j >= src_end ) break;
	s[j] = *e++;
      }
      s += step * word;
    }
  }
  char* s = src + len;
  if ( s >= src_end ) s = src_end - 1;
  *s = '\0';
}

/*
  ƱʸɤޤޤƤ뤫å

  char* cp : åʸɤǼʸ
  char c : åоݤʸ

   : 1 ... cpcޤޤƤ ; 0 ... cpcޤޤƤʤ
*/
int has_same_chara( char* cp, char c )
{
  for ( ; *cp != '\0' ; cp++ )
    if ( *cp == c ) return( 1 );

  return( 0 );
}

/*
  ʸν

  char* cp : ʸʸ
  char* removedChara : оݤʸɤǼʸ
*/
void remove_chara( char* cp, char* removed_chara )
{
  char* in = cp;
  char* out = cp;

  for ( ; *in != '\0' ; in++ ) {
    if ( has_same_chara( removed_chara, *in ) ) continue;
    *out++ = *in;
  }
  *out = '\0';
}

int main( int argc, char* argv[] )
{
  const int buffer_size = 1024;
  char* file_name[1];
  FILE* fp = NULL;
  char* src = NULL;
  char* enc = NULL;
  unsigned int step, word;
  int i;

  /* Υå */
  if ( ! init_arg( argc, argv, file_name, file_name + sizeof( file_name ) / sizeof( char* ), Option ) ) {
    help( "railfence : 졼롦ե󥹰Ź沽Ԥ", Option );
    return( -1 );
  }
  get_optvalue( get_opt( Option, "Help" ), &i );
  if ( is_opt_checked( get_opt( Option, "Help" ) ) ) {
    help( "railfence : 졼롦ե󥹰Ź沽Ԥ", Option );
    return( -1 );
  }
  if ( ! get_optvalue( get_opt( Option, "Step" ), &step ) ) return( -1 );
  if ( ! get_optvalue( get_opt( Option, "Word" ), &word ) ) return( -1 );

  /* Ź沽оʸХåեγ */
  if ( ( src = (char*)malloc( buffer_size ) ) == NULL )
    goto error_exit;

  /* Ź沽եɤ߹ */
  if ( file_name[0] == NULL ) {
    fp = stdin;
  } else {
    if ( ( fp = fopen( file_name[0], "r" ) ) == NULL )
      goto error_exit;
  }
  int size = fread( src, sizeof( char ), buffer_size - 1, fp );
  src[size] = '\0';
  if ( fp != stdin )
    fclose( fp );

  /* Ź沽ʸХåեγ */
  if ( ( enc = (char*)malloc( strlen( src ) + 1 ) ) == NULL )
    goto error_exit;

  /* Ź沽 */
  printf( "step=%d word=%d ignore blank=%d ignore newline=%d\n\n", step, word,
	  is_opt_checked( get_opt( Option, "Ignore Blank" ) ),
	  is_opt_checked( get_opt( Option, "Ignore Newline" ) ) );
  printf( "|%s|\n\t\n", src );

  if ( is_opt_checked( get_opt( Option, "Ignore Blank" ) ) )
    remove_chara( src, " \t" );
  if ( is_opt_checked( get_opt( Option, "Ignore Newline" ) ) )
    remove_chara( src, "\r\n" );

  rail_fence_encryption( src, enc, enc + strlen( src ) + 1, step, word );
  printf( "|%s|\n\t\n", enc );

  rail_fence_decryption( enc, src, src + strlen( src ) + 1, step, word );
  printf( "|%s|\n", src );

 error_exit:
  free( enc );
  free( src );

  return( 0 );
}
