/*
  $B49;z<00E9f(B
*/

#include "Substitution.h"

/*
  $B%-!<%3!<%I$N=EJ#$r=|30$9$k(B

  char* code : $B%-!<%3!<%I(B
*/
static void ex_dup_code( char* code )
{
  char* current = code + 1;
  if ( *code == '\0' || *current == '\0' ) return;

  while ( *current != '\0' ) {
    char* c;
    for ( c = current - 1 ; c >= code ; c-- )
      if ( *c == *current ) break;
    if ( c >= code ) {
      c = current;
      do {
	*c = *( c + 1 );
	c++;
      } while ( *c != '\0' );
    } else {
      current++;
    }
  }
}

/*
  $B%-!<%3!<%I$K4^$^$l$J$$J8;z$rJ?J8%3!<%I$+$i0E9f%3!<%I$X%3%T!<$9$k(B

  char* plain : $BJ?J8%3!<%I(B
  char* plain_end : $BJ?J8%3!<%I$NKvHx(B(NULL$B;~$OJ?J8%3!<%I$NKvHx%A%'%C%/$r9T$o$J$$(B)
  char** cipher : $B0E9f%3!<%I(B
  char* cipher_end: $B0E9f%3!<%I$NKvHx(B
  char* keyword : $B%-!<%3!<%I(B
*/
static void move_code( char* plain, char* plain_end, char** cipher, char* cipher_end, char* keyword )
{
  char* c;

  for ( ; *plain != '\0' ; plain++ ) {
    if ( plain_end != NULL && plain >= plain_end ) break;

    /* $BJ8;z$,%-!<%3!<%I$K4^$^$l$k$+$r%A%'%C%/$7$F!"4^$^$l$F$$$J$1$l$P0E9f%3!<%I$K%3%T!<(B */
    for ( c = keyword ; *c != '\0' ; c++ )
      if ( *c == *plain ) break;
    if ( *c == '\0' )
      *( ( *cipher )++ ) = *plain;
    if ( *cipher >= cipher_end - 1 )
      break;
  }
}

/*
  $BJ?J8%3!<%I$N:n@.(B
  ASCII$B%3!<%I$NCf$GI=<(2DG=$J$b$N$@$1$rCj=P$9$k(B

  char* plain : $BJ?J8%3!<%I(B
  char* plain_end : $BJ?J8%3!<%I$NKvHx(B
*/
void create_plain_code( char* plain, char* plain_end )
{
  char c = 1;

  while ( plain < plain_end && c != 0 ) {
    if ( isprint( c ) )
      *plain++ = c;
    c++;
  }
  *plain = '\0';
}

/*
  $B%-!<%3!<%I$r85$K0E9f%3!<%I$r:n@.$9$k(B
  $B%-!<%3!<%I$r@hF,$KJB$Y!"%-!<%3!<%I$NKvHx$N<!$NJ8;z$+$i=g$K%-!<%3!<%I$K4^$^$l$J$$J8;z$rDI2C$9$k(B

  char* plain : $BJ?J8%3!<%I(B
  char* cipher : $B:n@.$9$k0E9f%3!<%I$X$N%]%$%s%?(B
  char* cipher_end : $B0E9f%3!<%I$NKvHx(B
  char* keyword : $B%-!<%3!<%I(B
*/
void create_cipher_code( char* plain, char* cipher, char* cipher_end, char* keyword )
{
  char* p;
  char* c = cipher;

  ex_dup_code( keyword );
  if ( strlen( keyword ) > cipher_end - c ) return;
  strcpy( c, keyword );
  c += strlen( keyword );

  /* $B%-!<%3!<%I$NKvHx$NJ8;z$H0lCW$9$k$b$N$rJ?J8%3!<%I$+$iC5$9(B */
  for ( p = plain ; *p != '\0' ; p++ )
    if ( *( c - 1 ) == *p ) break;

  if ( *p != '\0' ) {
    p++;
    /* $B0lCW$7$?J8;z$,8+$D$+$C$?$i$=$N<!$NJ8;z$+$i%3%T!<(B */
    move_code( p, NULL, &c, cipher_end, keyword );
    /* $B<!$K@hF,$+$i;D$j$r%3%T!<(B */
    move_code( plain, p, &c, cipher_end, keyword );
  }

  *c = '\0';

  debug_print( get_opt( Option, "Debug" ), DEBUG_VERBOSE, "create_cipher_code : %s -> %s\n", plain, cipher );
}

/*
  $BJ8;zNs$+$i;XDj$7$?J8;z%3!<%I$N0LCV$r8!=P$7$FJV$9(B

  char* s : $BJ8;zNs(B
  char c : $BJ8;z%3!<%I(B

  $BLa$jCM(B : $BJ8;z$N0LCV(B($B8+$D$+$i$J$+$C$?>l9g$OIi?t(B)
*/
static int find_code( char* s, char c )
{
  if ( ! isprint( c ) ) return( -1 );
  char* cp = strchr( s, c );
  if ( cp == NULL ) return( -1 );

  return( cp - s );
}

/*
  $BJ8;zNs$NI=<((B
  $B0u;z2DG=$J$b$N$O$=$NJ8;z$r!"IT2DG=$J$b$N$OCM$r(B16$B?JI=<((B

  char* s : $BJ8;zNs(B
*/
static void print_data( char* s )
{
  while ( *s != '\0' ) {
    if ( isprint( *s ) )
      printf( "%c", *s );
    else
      printf( "[%x]", ( *s & 0xFF ) );
    s++;
  }
  printf( "\n" );
}

/*
  $B%+%(%5%k0E9f2=(B

  char* src : $B0E9f2=$r9T$&J8;zNs(B
  char* enc : $B0E9f2=$7$?7k2L$r3JG<$9$k%(%j%"$X$N%]%$%s%?(B
  char* enc_end : enc$B$NKvHx(B($BHV?M(B)
  char* plain : $BJ?J8J8;z%3!<%I(B
  unsigned int shift : $B%7%U%HNL(B
*/
void caesar_cipher_encode( char* src, char* enc, char* enc_end, char* plain, unsigned int shift )
{
  int len = strlen( plain );

  for ( ; *src != '\0' ; src++ ) {
    if ( enc >= enc_end - 1 ) break;
    int i = find_code( plain, *src );
    if ( i >= 0 )
      *enc++ = plain[(i + shift) % len];
  }
  *enc = '\0';
}

/*
  $B%+%(%5%kI|9f2=(B

  char* enc : $B0E9f2=$7$?J8;zNs(B
  char* src : $BI|9f2=$7$?7k2L$r3JG<$9$k%(%j%"$X$N%]%$%s%?(B
  char* src_end : src$B$NKvHx(B($BHV?M(B)
  char* plain : $BJ?J8J8;z%3!<%I(B
  unsigned int shift : $B%7%U%HNL(B
*/
void caesar_cipher_decode( char* enc, char* src, char* src_end, char* plain, unsigned int shift )
{
  int len = strlen( plain );

  for ( ; *enc != '\0' ; enc++ ) {
    if ( src >= src_end - 1 ) break;
    int i = find_code( plain, *enc );
    if ( i >= 0 ) {
      i -= shift;
      if ( i < 0 ) i += len;
      *src++ = plain[i];
    }
  }
  *src = '\0';
}

/*
  $BC10l49;z<00E9f2=(B/$BI|9f2=(B

  char* src : $B0E9f2=(B/$BI|9f2=$r9T$&J8;zNs(B
  char* enc : $B0E9f2=(B/$BI|9f2=$7$?7k2L$r3JG<$9$k%(%j%"$X$N%]%$%s%?(B
  char* enc_end : enc$B$NKvHx(B($BHV?M(B)
  char* plain : $BJ?J8J8;z%3!<%I(B
  char* cipher : $B0E9fJ8;z%3!<%I(B
*/
void substitution( char* src, char* enc, char* enc_end, char* plain, char* cipher )
{
  for ( ; *src != '\0' ; src++ ) {
    int j = find_code( plain, *src );
    if ( j >= 0 ) {
      if ( enc >= enc_end ) break;
      *enc++ = cipher[j];
    }
  }
  *enc = '\0';
}

/*
  $B%t%#%8%e%M%k0E9f2=(B

  char* src : $B0E9f2=$r9T$&J8;zNs(B
  char* enc : $B0E9f2=$7$?7k2L$r3JG<$9$k%(%j%"$X$N%]%$%s%?(B
  char* enc_end : enc$B$NKvHx(B($BHV?M(B)
  char* plain : $BJ?J8J8;z%3!<%I(B
  char* key : $B%-!<%3!<%I(B
*/
void vigenere_cipher_encode( char* src, char* enc, char* enc_end, char* plain, char* key )
{
  char* key_buf = key;
  unsigned int len = strlen( plain );

  while ( *src != '\0' ) {
    if ( enc >= enc_end - 1 ) break;
    int k = find_code( plain, *key_buf );
    int s = find_code( plain, *src++ );
    if ( k >= 0 && s >= 0 ) {
      *enc++ = plain[( s + k ) % len ];
      if ( *(++key_buf) == '\0' ) key_buf = key;
    }
  }
  *enc = '\0';
}

/*
  $B%t%#%8%e%M%kI|9f2=(B

  char* enc : $B0E9f2=$7$?J8;zNs(B
  char* src : $BI|9f2=$7$?7k2L$r3JG<$9$k%(%j%"$X$N%]%$%s%?(B
  char* src_end : src$B$NKvHx(B($BHV?M(B)
  char* plain : $BJ?J8J8;z%3!<%I(B
  char* key : $B%-!<%3!<%I(B
*/
void vigenere_cipher_decode( char* enc, char* src, char* src_end, char* plain, char* key )
{
  char* key_buf = key;
  unsigned int len = strlen( plain );

  while ( *enc != '\0' ) {
    if ( src >= src_end - 1 ) break;
    int k = find_code( plain, *key_buf );
    int e = find_code( plain, *enc++ );
    if ( k >= 0 && e >= 0 ) {
      if ( e < k ) e += len;
      *src++ = plain[e - k];
      if ( *(++key_buf) == '\0' ) key_buf = key;
    }
  }
  *src = '\0';
}

int main( int argc, char* argv[] )
{
  char* file_name[1];
  char* key = key_code;
  int shift;
  char* src = NULL;
  char* enc = NULL;
  const unsigned int buffer_size = 1024;
  FILE* fp = NULL;
  int cipherType;
  char* cp;

  init_arg( argc, argv, file_name, &file_name[sizeof(file_name) / sizeof(char*)], Option );
  if ( is_opt_checked( get_opt( Option, "Help" ) ) ) {
    help( "Usage : substitution [-edkstvh]", Option );
    return( -1 );
  }
  /* $B0E9f2=J}K!$N<hF@(B */
  if ( ! get_optvalue( get_opt( Option, "Type" ), &cp ) )
    goto error_exit;
  cipherType = tolower( *cp );
  debug_print( get_opt( Option, "Debug" ), DEBUG_VERBOSE, "cipher type=%c\n", *cp );
  /* $B%-!<%3!<%I$N<hF@(B */
  if ( ! get_optvalue( get_opt( Option, "Key" ), &key ) )
    goto error_exit;
  debug_print( get_opt( Option, "Debug" ), DEBUG_VERBOSE, "key value=%s\n", key );
  /* $B%7%U%HNL$N<hF@(B */
  if ( ! get_optvalue( get_opt( Option, "Shift" ), &shift ) )
    goto error_exit;
  debug_print( get_opt( Option, "Debug" ), DEBUG_VERBOSE, "shift value=%d\n", shift );

  /* $BJ?J8J8;z%3!<%I$H0E9fJ8;z%3!<%I$N:n@.(B */
  create_plain_code( plain_code, &plain_code[sizeof(plain_code) / sizeof( char )] );
  if ( cipherType == CIPHER_SUBST )
    create_cipher_code( plain_code, cipher_code, &cipher_code[sizeof(cipher_code) / sizeof( char )], key );

  /* $B0E9f2=BP>]J8;zNs%P%C%U%!$N3NJ](B */
  if ( ( src = (char*)malloc( buffer_size ) ) == NULL )
    goto error_exit;
  /* $B0E9f2=7k2LJ8;zNs%P%C%U%!$N3NJ](B */
  if ( ( enc = (char*)malloc( buffer_size ) ) == NULL )
    goto error_exit;

  /* $B0E9f2=$9$k%U%!%$%k$NFI$_9~$_(B */
  if ( file_name[0] == NULL ) {
    fp = stdin;
  } else {
    if ( ( fp = fopen( file_name[0], "r" ) ) == NULL )
      goto error_exit;
  }
  while ( fgets( src, buffer_size, fp ) != NULL ) {
    if ( is_opt_checked( get_opt( Option, "Decode" ) ) ) { /* $BI|9f2==hM}(B */
      switch ( cipherType ) {
      case CIPHER_VIGENERE :
	vigenere_cipher_decode( src, enc, &enc[buffer_size], plain_code, key );
	break;
      case CIPHER_SUBST :
	substitution( src, enc, &enc[buffer_size], cipher_code, plain_code );
	break;
      case CIPHER_CAESAR :
	caesar_cipher_decode( src, enc, &enc[buffer_size], plain_code, shift );
	break;
      }
    } else {                                               /* $B0E9f2==hM}(B */
      switch ( cipherType ) {
      case CIPHER_VIGENERE :
	vigenere_cipher_encode( src, enc, &enc[buffer_size], plain_code, key );
	break;
      case CIPHER_SUBST :
	substitution( src, enc, &enc[buffer_size], plain_code, cipher_code );
	break;
      case CIPHER_CAESAR :
	caesar_cipher_encode( src, enc, &enc[buffer_size], plain_code, shift );
	break;
      }
    }
    print_data( enc );
  }

 error_exit:
  free( enc );
  free( src );
  if ( fp != NULL && fp != stdin )
    fclose( fp );

  return( 0 );
}
