#ifndef SUBSTITUTION_H
#define SUBSTITUTION_H

#include <ctype.h>
#include <string.h>
#include <limits.h>
#include "misc.h"

enum DEBUG_LEVEL {
  DEBUG_SILENT = 0,
  DEBUG_NORMAL = 1,
  DEBUG_VERBOSE = 2,
  DEBUG_ALL = 3,
};

enum CIPHER_TYPE {
  CIPHER_CAESAR = 'c',
  CIPHER_SUBST = 's',
  CIPHER_VIGENERE = 'v',
};

/*
static char plain_code[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!\"#$%&'()~-=^|\\`@{[+;*:}]<,>.?/_ \t\r\n";
static char cipher_code[sizeof(plain_code) / sizeof( char )];
*/
static char plain_code[UCHAR_MAX];
static char cipher_code[UCHAR_MAX];

static char key_code[] = "Key";

/*
  char* ident, char tag, char* help,
  int hasValue, int valueType, char* maxValue, char* minValue, int checked, char* defaultValue, char* value
*/
static OptionType Option[] = {
  { "Encode", 'e', "$B0E9f2=$r9T$&(B",
    0, OPTION_TYPE_NONE,   NULL, NULL, 1,     NULL, NULL, },
  { "Decode", 'd', "$BI|9f2=$r9T$&(B",
    0, OPTION_TYPE_NONE,   NULL, NULL, 0,     NULL, NULL, },
  { "Key", 'k', "$B0E9f2=$K;H$&%-!<$r;XDj$9$k(B(-k[KeyCode])",
    1, OPTION_TYPE_STRING, NULL, NULL, 1, key_code, NULL, },
  { "Shift", 's', "$B%7%U%HNL$r@_Dj$9$k(B<$B%+%(%5%k%7%U%H$N$_M-8z(B>(-s[ShiftValue])",
    1, OPTION_TYPE_INT,    "10",  "0", 0,      "3", NULL, },
  { "Type",  't', "$B0E9f2=J}K!$r;XDj$9$k(B(c=caesar,s=subst,v=vigenere)",
    1, OPTION_TYPE_STRING, NULL, NULL, 1,      "s", NULL },

  { "Debug", 'v', "$B%G%P%C%0%l%Y%k(B",
    1, OPTION_TYPE_INT,     "3",  "0", 1,      "1", NULL, },
  { "Help", 'h', "$B%X%k%W(B",
    0, OPTION_TYPE_NONE,   NULL, NULL, 0,     NULL, NULL, },

  { NULL,          0,   NULL,
    0, OPTION_TYPE_NONE,   NULL, NULL, 0,     NULL, NULL, },
};

#endif
