#include "misc.h"

static int strtol_with_check( char* param, int* val )
{
  char* c;

  *val = strtol( param, &c, 10 );

  return( ( c == param || *c != '\0' ) ? 0 : 1 );
}

static int strtod_with_check( char* param, double* val )
{
  char* c;

  *val = strtod( param, &c );

  return( ( c == param || *c != '\0' ) ? 0 : 1 );
}

/*
  ǥХåѽ

  int level : ǥХå٥
  char* fmt : 
*/
void debug_print( OptionType* o, int level, char* fmt, ... )
{
  va_list argp;
  int option_value;

  if ( ! get_optvalue( o, &option_value ) ) return;
  if ( level > option_value ) return;

  va_start( argp, fmt );
  vprintf( fmt, argp );
  va_end( argp );
}

/*
  إɽ
*/
void help( char* first_message, OptionType* o )
{
  fprintf( stderr, "%s\n", first_message );
  for ( ; o->ident != NULL ; o++ ) {
    fprintf( stderr, "\t-%c ... %s", o->tag, o->help );
    if ( o->hasValue ) {
      if ( o->valueType == OPTION_TYPE_INT || o->valueType == OPTION_TYPE_DOUBLE )
	fprintf( stderr, "(%s-%s) default=%s", o->minValue, o->maxValue, o->defaultValue );
      else
	fprintf( stderr, " default=%s", o->defaultValue );
    }
    fprintf( stderr, "\n" );
  }
}

/*
  ץμ

  OptionType* o : ץƬݥ
  char* ident : ̻

   : ŪΥץؤΥݥ(ĤʤäNULL)
*/
OptionType* get_opt( OptionType* o, char* ident )
{
  for ( ; o->ident != NULL ; o++ )
    if ( strcmp( ident, o->ident ) == 0 )
      return( o );

  return( NULL );
}

/*
  ץμ

  OptionType* o : оݤΥץ
  void* value : ͤǼݥ

   : (1) / (0)
*/
int get_optvalue( OptionType* o, void* value )
{
  char** c;

  if ( o == NULL ) return( 0 );
  if ( ! o->hasValue ) return( 0 );

  switch ( o->valueType ) {
  case OPTION_TYPE_INT :
    if ( ! strtol_with_check( o->value, (int*)value ) ) return( 0 );
    break;
  case OPTION_TYPE_DOUBLE :
    if ( ! strtod_with_check( o->value, (double*)value ) ) return( 0 );
    break;
  default:
    c = (char**)value;
    *c = o->value;
  }

  return( 1 );
}

int is_opt_checked( OptionType* o )
{
  if ( o == NULL ) return( 0 );
  return( o->checked );
}

/*

  β

  int* argc : ο򼨤
  char** argv[] : 

   :  = 1 ,  = 0
*/
int init_arg( int argc, char* argv[], char** param, char** param_end, OptionType* option )
{
  int i;
  int i_val, i_max, i_min;
  double d_val, d_max, d_min;
  OptionType* o;
  char** cpp;

  /* ץȰͤǥեͤǽ */
  for ( o = option ; o->ident != NULL ; o++ )
    o->value = o->defaultValue;
  for ( cpp = param ; cpp < param_end ; cpp++ )
    *cpp = NULL;

  for ( i = 1 ; i < argc ; i++ ) {
    if ( strncmp( argv[i], "-", 1 ) == 0 ) {
      for ( o = option ; o->ident != NULL ; o++ )
        if ( o->tag == (char)tolower( (int)argv[i][1] ) ) break;
      if ( o->ident == NULL ) return( 0 );
      o->checked = 1;
      /* դץ */
      if ( o->hasValue ) {
	/* ͤꤵƤʤХǥեͤΤޤ */
	if ( argv[i][2] == '\0' )
	  continue;
	switch ( o->valueType ) {
	case OPTION_TYPE_INT :
	  if ( ! strtol_with_check( &( argv[i][2] ), &i_val ) ) return( 0 );
	  if ( ! strtol_with_check( o->minValue, &i_min ) ) return( 0 );
	  if ( ! strtol_with_check( o->maxValue, &i_max ) ) return( 0 );
	  if ( i_val < i_min || i_val > i_max ) return( 0 );
	  break;
	case OPTION_TYPE_DOUBLE :
	  if ( ! strtod_with_check( &( argv[i][2] ), &d_val ) ) return( 0 );
	  if ( ! strtod_with_check( o->minValue, &d_min ) ) return( 0 );
	  if ( ! strtod_with_check( o->maxValue, &d_max ) ) return( 0 );
	  if ( d_val < d_min || d_val > d_max ) return( 0 );
	}
	o->value = &( argv[i][2] );
      }
    } else {
      if ( param >= param_end ) return( 0 );
      *param++ = argv[i];
    }
  }

  return( 1 );
}

