#ifndef MISC_H
#define MISC_H

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>

enum OPTION_TYPE {
  OPTION_TYPE_INT,
  OPTION_TYPE_DOUBLE,
  OPTION_TYPE_STRING,
  OPTION_TYPE_NONE,
};

typedef struct OptionType {
  char* ident;
  char tag;
  char* help;
  int hasValue;
  int valueType;
  char* maxValue;
  char* minValue;
  int checked;
  char* defaultValue;
  char* value;
} OptionType;

void debug_print( OptionType*, int, char*, ... );
void help( char*, OptionType* );
OptionType* get_opt( OptionType*, char* );
int get_optvalue( OptionType*, void* );
int is_opt_checked( OptionType* );
int init_arg( int, char**, char**, char**, OptionType* );

#endif
